using System;

namespace MP3Cleaner
{
	/// <summary>
	/// Summary description for Config.
	/// </summary>
	public class Config
	{
		//match criteria
		private bool mcFileName;
		private bool mcFileSize;
		private bool mcSongTitle;
		private bool mcAlbumTrack;
		private bool mcSimilar;

		//delete options
		private bool doFileName;
		private bool doFileSize;
		private bool doSongTitle;
		private bool doAlbumTrack;
		private bool doSimilar;

		//directory
		private String dirName;

		//match similar % words
		private int mcPercentSimilar;

		public Config()
		{
		}

		public void LoadConfig()
		{
			try
			{
				System.IO.StreamReader myStream = new System.IO.StreamReader("config.cfg");
				if(-1 == myStream.Peek())
				{
					mcFileName = true;
					mcFileSize = true;
					mcSongTitle = true;
					mcAlbumTrack = true;
					mcSimilar = true;
					mcPercentSimilar = 65;

					doFileName = false;
					doFileSize = false;
					doSongTitle = false;
					doAlbumTrack = false;
					doSimilar = true;

					dirName = "";
				}
				else
				{
					mcFileName = GetValue( myStream );
					mcFileSize = GetValue( myStream );
					mcSongTitle = GetValue( myStream );
					mcAlbumTrack = GetValue( myStream );
					mcSimilar = GetValue( myStream );
					mcPercentSimilar = System.Int32.Parse(myStream.ReadLine());

					doFileName = GetValue( myStream );
					doFileSize = GetValue( myStream );
					doSongTitle = GetValue( myStream );
					doAlbumTrack = GetValue( myStream );
					doSimilar = GetValue( myStream );

					dirName = myStream.ReadLine();
				}

				myStream.Close();
			}
			catch(Exception e)
			{
				mcFileName = true;
				mcFileSize = true;
				mcSongTitle = true;
				mcAlbumTrack = true;
				mcSimilar = true;
				mcPercentSimilar = 65;

				doFileName = false;
				doFileSize = false;
				doSongTitle = false;
				doAlbumTrack = false;
				doSimilar = true;

				dirName = "";
			}
		}

		private bool GetValue(System.IO.StreamReader myStream)
		{
			if( 0 == myStream.ReadLine().CompareTo("1"))
				return true;
			else
				return false;
		}

		public void SaveConfig()
		{
			System.IO.StreamWriter myStream = new System.IO.StreamWriter("config.cfg",false);
			
			myStream.WriteLine(mcFileName?"1":"0");
			myStream.WriteLine(mcFileSize?"1":"0");
			myStream.WriteLine(mcSongTitle?"1":"0");
			myStream.WriteLine(mcAlbumTrack?"1":"0");
			myStream.WriteLine(mcSimilar?"1":"0");
			myStream.WriteLine(mcPercentSimilar);

			myStream.WriteLine(doFileName?"1":"0");
			myStream.WriteLine(doFileSize?"1":"0");
			myStream.WriteLine(doSongTitle?"1":"0");
			myStream.WriteLine(doAlbumTrack?"1":"0");
			myStream.WriteLine(doSimilar?"1":"0");
			
			myStream.WriteLine(dirName);

			myStream.Flush();
			myStream.Close();
		}

		public bool MatchFileName{
			get{return mcFileName;}
			set{mcFileName = value;}
		}
		public bool MatchFileSize
		{
			get{return mcFileSize;}
			set{mcFileSize = value;}
		}
		public bool MatchSongTitle
		{
			get{return mcSongTitle;}
			set{mcSongTitle = value;}
		}
		public bool MatchAlbumTrack
		{
			get{return mcAlbumTrack;}
			set{mcAlbumTrack = value;}
		}
		public bool MatchSimilar
		{
			get{return mcSimilar;}
			set{mcSimilar = value;}
		}
		public int MatchPercentSimilar
		{
			get{return mcPercentSimilar;}
			set{mcPercentSimilar = value;}
		}

		


		public bool DelPromptFileName
		{
			get{return doFileName;}
			set{doFileName = value;}
		}
		public bool DelPromptFileSize
		{
			get{return doFileSize;}
			set{doFileSize = value;}
		}
		public bool DelPromptSongTitle
		{
			get{return doSongTitle;}
			set{doSongTitle = value;}
		}
		public bool DelPromptAlbumTrack
		{
			get{return doAlbumTrack;}
			set{doAlbumTrack = value;}
		}
		public bool DelPromptSimilar
		{
			get{return doSimilar;}
			set{doSimilar = value;}
		}

		public String DirName
		{
			get{return dirName;}
			set{dirName = value;}
		}
	}
}
