using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Threading;

namespace MP3Cleaner
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class GUI : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox cbFileName;
		private System.Windows.Forms.CheckBox cbFileSize;
		private System.Windows.Forms.CheckBox cbSongTitle;
		private System.Windows.Forms.CheckBox cbAlbumTrack;
		private System.Windows.Forms.CheckBox cbSimilarFileNames;
		private System.Windows.Forms.NumericUpDown percentWordsMatching;
		private System.Windows.Forms.GroupBox Options;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button btDirectoryBrowse;
		private System.Windows.Forms.TextBox tbDirectory;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.CheckBox cbDeleteFileName;
		private System.Windows.Forms.CheckBox cbDeleteFileSize;
		private System.Windows.Forms.CheckBox cbDeleteSongTitle;
		private System.Windows.Forms.CheckBox cbDeleteAlbumTrack;
		private System.Windows.Forms.CheckBox cbDeleteSimilar;
		private System.Windows.Forms.RadioButton rbPrompOnly;
		private System.Windows.Forms.RadioButton rbAllowDelete;
		private System.Windows.Forms.Button btStart;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private Config MyConfig;

		public GUI()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			MyConfig = new Config();
			MyConfig.LoadConfig();

			cbFileName.Checked = MyConfig.MatchFileName;
			cbFileSize.Checked = MyConfig.MatchFileSize;
			cbSongTitle.Checked = MyConfig.MatchSongTitle;
			cbAlbumTrack.Checked = MyConfig.MatchAlbumTrack;
			cbSimilarFileNames.Checked = MyConfig.MatchSimilar;
			percentWordsMatching.Value = MyConfig.MatchPercentSimilar;

			cbDeleteFileName.Checked = MyConfig.DelPromptFileName;
			cbDeleteFileSize.Checked = MyConfig.DelPromptFileSize;
			cbDeleteSongTitle.Checked = MyConfig.DelPromptSongTitle;
			cbDeleteAlbumTrack.Checked = MyConfig.DelPromptAlbumTrack;
			cbDeleteSimilar.Checked = MyConfig.DelPromptSimilar;

			tbDirectory.Text = MyConfig.DirName;



			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			UpdateConfig();
			MyConfig.SaveConfig();

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cbFileName = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.cbSongTitle = new System.Windows.Forms.CheckBox();
			this.cbFileSize = new System.Windows.Forms.CheckBox();
			this.cbSimilarFileNames = new System.Windows.Forms.CheckBox();
			this.percentWordsMatching = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.cbAlbumTrack = new System.Windows.Forms.CheckBox();
			this.Options = new System.Windows.Forms.GroupBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.cbDeleteAlbumTrack = new System.Windows.Forms.CheckBox();
			this.cbDeleteSongTitle = new System.Windows.Forms.CheckBox();
			this.cbDeleteFileName = new System.Windows.Forms.CheckBox();
			this.cbDeleteFileSize = new System.Windows.Forms.CheckBox();
			this.rbAllowDelete = new System.Windows.Forms.RadioButton();
			this.rbPrompOnly = new System.Windows.Forms.RadioButton();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.tbDirectory = new System.Windows.Forms.TextBox();
			this.btDirectoryBrowse = new System.Windows.Forms.Button();
			this.cbDeleteSimilar = new System.Windows.Forms.CheckBox();
			this.btStart = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.percentWordsMatching)).BeginInit();
			this.Options.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// cbFileName
			// 
			this.cbFileName.Checked = true;
			this.cbFileName.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbFileName.Location = new System.Drawing.Point(8, 32);
			this.cbFileName.Name = "cbFileName";
			this.cbFileName.TabIndex = 0;
			this.cbFileName.Text = "File Name";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.cbSongTitle,
																					this.cbFileSize,
																					this.cbSimilarFileNames,
																					this.percentWordsMatching,
																					this.label1});
			this.groupBox1.Location = new System.Drawing.Point(0, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(184, 240);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Match Criteria";
			// 
			// cbSongTitle
			// 
			this.cbSongTitle.Checked = true;
			this.cbSongTitle.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbSongTitle.Location = new System.Drawing.Point(8, 72);
			this.cbSongTitle.Name = "cbSongTitle";
			this.cbSongTitle.TabIndex = 2;
			this.cbSongTitle.Text = "Song Title";
			// 
			// cbFileSize
			// 
			this.cbFileSize.Checked = true;
			this.cbFileSize.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbFileSize.Location = new System.Drawing.Point(8, 48);
			this.cbFileSize.Name = "cbFileSize";
			this.cbFileSize.TabIndex = 1;
			this.cbFileSize.Text = "File Size";
			// 
			// cbSimilarFileNames
			// 
			this.cbSimilarFileNames.Checked = true;
			this.cbSimilarFileNames.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbSimilarFileNames.Location = new System.Drawing.Point(8, 120);
			this.cbSimilarFileNames.Name = "cbSimilarFileNames";
			this.cbSimilarFileNames.Size = new System.Drawing.Size(128, 24);
			this.cbSimilarFileNames.TabIndex = 3;
			this.cbSimilarFileNames.Text = "Similar File Names";
			this.cbSimilarFileNames.CheckedChanged += new System.EventHandler(this.cbSimilarFileNamesChecked);
			// 
			// percentWordsMatching
			// 
			this.percentWordsMatching.Location = new System.Drawing.Point(24, 144);
			this.percentWordsMatching.Minimum = new System.Decimal(new int[] {
																				 1,
																				 0,
																				 0,
																				 0});
			this.percentWordsMatching.Name = "percentWordsMatching";
			this.percentWordsMatching.Size = new System.Drawing.Size(40, 20);
			this.percentWordsMatching.TabIndex = 3;
			this.percentWordsMatching.Value = new System.Decimal(new int[] {
																			   65,
																			   0,
																			   0,
																			   0});
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(64, 144);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "% Words Matching";
			// 
			// cbAlbumTrack
			// 
			this.cbAlbumTrack.Checked = true;
			this.cbAlbumTrack.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbAlbumTrack.Location = new System.Drawing.Point(8, 104);
			this.cbAlbumTrack.Name = "cbAlbumTrack";
			this.cbAlbumTrack.TabIndex = 2;
			this.cbAlbumTrack.Text = "Album + Track";
			// 
			// Options
			// 
			this.Options.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.groupBox3,
																				  this.rbAllowDelete,
																				  this.rbPrompOnly});
			this.Options.Location = new System.Drawing.Point(192, 8);
			this.Options.Name = "Options";
			this.Options.Size = new System.Drawing.Size(184, 240);
			this.Options.TabIndex = 3;
			this.Options.TabStop = false;
			this.Options.Text = "Options";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.cbDeleteAlbumTrack,
																					this.cbDeleteSongTitle,
																					this.cbDeleteFileName,
																					this.cbDeleteFileSize});
			this.groupBox3.Location = new System.Drawing.Point(8, 80);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(168, 152);
			this.groupBox3.TabIndex = 2;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Prompt Before Delete";
			this.groupBox3.Enter += new System.EventHandler(this.groupBox3_Enter);
			// 
			// cbDeleteAlbumTrack
			// 
			this.cbDeleteAlbumTrack.Location = new System.Drawing.Point(24, 96);
			this.cbDeleteAlbumTrack.Name = "cbDeleteAlbumTrack";
			this.cbDeleteAlbumTrack.TabIndex = 7;
			this.cbDeleteAlbumTrack.Text = "Album + Track";
			// 
			// cbDeleteSongTitle
			// 
			this.cbDeleteSongTitle.Location = new System.Drawing.Point(24, 72);
			this.cbDeleteSongTitle.Name = "cbDeleteSongTitle";
			this.cbDeleteSongTitle.TabIndex = 6;
			this.cbDeleteSongTitle.Text = "Song Title";
			// 
			// cbDeleteFileName
			// 
			this.cbDeleteFileName.Location = new System.Drawing.Point(24, 24);
			this.cbDeleteFileName.Name = "cbDeleteFileName";
			this.cbDeleteFileName.TabIndex = 5;
			this.cbDeleteFileName.Text = "File Name";
			// 
			// cbDeleteFileSize
			// 
			this.cbDeleteFileSize.Location = new System.Drawing.Point(24, 48);
			this.cbDeleteFileSize.Name = "cbDeleteFileSize";
			this.cbDeleteFileSize.TabIndex = 5;
			this.cbDeleteFileSize.Text = "File Size";
			// 
			// rbAllowDelete
			// 
			this.rbAllowDelete.Checked = true;
			this.rbAllowDelete.Location = new System.Drawing.Point(16, 48);
			this.rbAllowDelete.Name = "rbAllowDelete";
			this.rbAllowDelete.Size = new System.Drawing.Size(152, 24);
			this.rbAllowDelete.TabIndex = 1;
			this.rbAllowDelete.TabStop = true;
			this.rbAllowDelete.Text = "On Match Allow Delete";
			this.rbAllowDelete.CheckedChanged += new System.EventHandler(this.rbAllowDelete_CheckedChanged);
			// 
			// rbPrompOnly
			// 
			this.rbPrompOnly.Location = new System.Drawing.Point(16, 24);
			this.rbPrompOnly.Name = "rbPrompOnly";
			this.rbPrompOnly.Size = new System.Drawing.Size(152, 24);
			this.rbPrompOnly.TabIndex = 0;
			this.rbPrompOnly.Text = "On Match Notify Only";
			this.rbPrompOnly.CheckedChanged += new System.EventHandler(this.rbPrompOnly_CheckedChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.tbDirectory,
																					this.btDirectoryBrowse});
			this.groupBox2.Location = new System.Drawing.Point(0, 248);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(376, 48);
			this.groupBox2.TabIndex = 4;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Directory";
			// 
			// tbDirectory
			// 
			this.tbDirectory.Location = new System.Drawing.Point(8, 16);
			this.tbDirectory.Name = "tbDirectory";
			this.tbDirectory.Size = new System.Drawing.Size(248, 20);
			this.tbDirectory.TabIndex = 1;
			this.tbDirectory.Text = "";
			// 
			// btDirectoryBrowse
			// 
			this.btDirectoryBrowse.Location = new System.Drawing.Point(264, 16);
			this.btDirectoryBrowse.Name = "btDirectoryBrowse";
			this.btDirectoryBrowse.Size = new System.Drawing.Size(96, 24);
			this.btDirectoryBrowse.TabIndex = 0;
			this.btDirectoryBrowse.Text = "Browse";
			this.btDirectoryBrowse.Click += new System.EventHandler(this.BrowseForDirectory);
			// 
			// cbDeleteSimilar
			// 
			this.cbDeleteSimilar.Checked = true;
			this.cbDeleteSimilar.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbDeleteSimilar.Location = new System.Drawing.Point(224, 208);
			this.cbDeleteSimilar.Name = "cbDeleteSimilar";
			this.cbDeleteSimilar.Size = new System.Drawing.Size(120, 24);
			this.cbDeleteSimilar.TabIndex = 5;
			this.cbDeleteSimilar.Text = "Similar File Names";
			// 
			// btStart
			// 
			this.btStart.Location = new System.Drawing.Point(136, 304);
			this.btStart.Name = "btStart";
			this.btStart.Size = new System.Drawing.Size(96, 24);
			this.btStart.TabIndex = 7;
			this.btStart.Text = "Start";
			this.btStart.Click += new System.EventHandler(this.btStart_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 307);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "www.Knez.org";
			this.label2.Click += new System.EventHandler(this.label2_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(272, 307);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(96, 16);
			this.label3.TabIndex = 8;
			this.label3.Text = "MP3Cleaner v1.0";
			// 
			// GUI
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 333);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label3,
																		  this.btStart,
																		  this.cbDeleteSimilar,
																		  this.groupBox2,
																		  this.Options,
																		  this.cbAlbumTrack,
																		  this.cbFileName,
																		  this.groupBox1,
																		  this.label2});
			this.Name = "GUI";
			this.Text = "MP3Cleaner";
			this.Load += new System.EventHandler(this.GUI_Load);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.percentWordsMatching)).EndInit();
			this.Options.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new GUI());
		}

		private void cbSimilarFileNamesChecked(object sender, System.EventArgs e)
		{
			//means cbSimilarFileNames was changed
			if( true == ((CheckBox)sender).Checked )
			{
				percentWordsMatching.Enabled = true;
			}
			if( false == ((CheckBox)sender).Checked )
			{
				percentWordsMatching.Enabled = false;
			}
		}

		private void BrowseForDirectory(object sender, System.EventArgs e)
		{
			
			Shell32.ShellClass shell = new Shell32.ShellClass();
			Shell32.Folder2 folder = (Shell32.Folder2)shell.BrowseForFolder(
				this.Handle.ToInt32(), // Window handle as type int
				"Select Folder...", // Window caption
				0x0200| //dont show new folder button
				0x0010| //add an edit box for the path
				0x0020| //insite on a valid value before closing
				0x0040, //new dialog style
				null // Optional root folder, default is Desktop
				);

			//make sure to check if they hit cancel !!!!!!!!!!!!!
			if( null != folder)
				tbDirectory.Text = folder.Self.Path;
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
		
		}

		private void GUI_Load(object sender, System.EventArgs e)
		{
		
		}

		private void groupBox3_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void rbPrompOnly_CheckedChanged(object sender, System.EventArgs e)
		{
			cbDeleteFileName.Enabled = false;
			cbDeleteFileSize.Enabled = false;
			cbDeleteSongTitle.Enabled = false;
			cbDeleteAlbumTrack.Enabled = false;
			cbDeleteSimilar.Enabled = false;
		}

		private void rbAllowDelete_CheckedChanged(object sender, System.EventArgs e)
		{
			cbDeleteFileName.Enabled = true;
			cbDeleteFileSize.Enabled = true;
			cbDeleteSongTitle.Enabled = true;
			cbDeleteAlbumTrack.Enabled = true;
			cbDeleteSimilar.Enabled = true;
		}

		private void btStart_Click(object sender, System.EventArgs e)
		{
			Config myConfig = UpdateConfig();
			GUIStatus myStatus = new GUIStatus(myConfig);
			myStatus.Show();

			ThreadStart myThreadStart = new ThreadStart(myStatus.Run);
			Thread myThread = new Thread(myThreadStart);
			myThread.Start();
		}

		private Config UpdateConfig()
		{
			//set the delete options
			if( rbPrompOnly.Checked )
			{
				//they dont really want to delete anything
				MyConfig.DelPromptFileName = false;
				MyConfig.DelPromptFileSize = false;
				MyConfig.DelPromptSongTitle = false;
				MyConfig.DelPromptAlbumTrack = false;
				MyConfig.DelPromptSimilar = false;
			}
			else
			{
				MyConfig.DelPromptFileName = cbDeleteFileName.Checked;
				MyConfig.DelPromptFileSize = cbDeleteFileSize.Checked;
				MyConfig.DelPromptSongTitle = cbDeleteSongTitle.Checked;
				MyConfig.DelPromptAlbumTrack = cbDeleteAlbumTrack.Checked;
				MyConfig.DelPromptSimilar = cbDeleteSimilar.Checked;
			}

			//now get the %words that match
			MyConfig.MatchPercentSimilar = (int)percentWordsMatching.Value;

			//now set the match criteria
			MyConfig.MatchFileName = cbFileName.Checked;
			MyConfig.MatchFileSize = cbFileSize.Checked;
			MyConfig.MatchSongTitle = cbSongTitle.Checked;
			MyConfig.MatchAlbumTrack = cbAlbumTrack.Checked;
			MyConfig.MatchSimilar = cbSimilarFileNames.Checked;

			//finally get the directory
			MyConfig.DirName = tbDirectory.Text;

			return MyConfig;
		}

		private void label2_Click(object sender, System.EventArgs e)
		{
		
		}
	}
}
