using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;

namespace MP3Cleaner
{
	/// <summary>
	/// Summary description for GUIStatus.
	/// </summary>
	public class GUIStatus : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btCancel;
		private System.Windows.Forms.ProgressBar pbProgress;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Config Config;
		private System.Windows.Forms.RichTextBox tbStatus;
		private MP3Cleaner MyMP3Cleaner;

		public GUIStatus(Config configuration)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.Config = configuration;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btCancel = new System.Windows.Forms.Button();
			this.pbProgress = new System.Windows.Forms.ProgressBar();
			this.tbStatus = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// btCancel
			// 
			this.btCancel.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btCancel.Location = new System.Drawing.Point(312, 152);
			this.btCancel.Name = "btCancel";
			this.btCancel.Size = new System.Drawing.Size(88, 24);
			this.btCancel.TabIndex = 0;
			this.btCancel.Text = "Cancel";
			this.btCancel.Click += new System.EventHandler(this.btCancel_Click);
			// 
			// pbProgress
			// 
			this.pbProgress.Location = new System.Drawing.Point(0, 152);
			this.pbProgress.Name = "pbProgress";
			this.pbProgress.Size = new System.Drawing.Size(304, 24);
			this.pbProgress.TabIndex = 1;
			// 
			// tbStatus
			// 
			this.tbStatus.Name = "tbStatus";
			this.tbStatus.Size = new System.Drawing.Size(400, 144);
			this.tbStatus.TabIndex = 4;
			this.tbStatus.Text = "";
			// 
			// GUIStatus
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 181);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tbStatus,
																		  this.pbProgress,
																		  this.btCancel});
			this.Name = "GUIStatus";
			this.Text = "GUIStatus";
			this.Load += new System.EventHandler(this.GUIStatus_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void GUIStatus_Load(object sender, System.EventArgs e)
		{
		
		}

		public void Run()
		{
			MyMP3Cleaner = new MP3Cleaner(Config,this);

			ThreadStart myThreadStart = new ThreadStart(MyMP3Cleaner.Run);
			Thread myThread = new Thread(myThreadStart);
			myThread.Start();
		}

		public void SetProgressRange(int maxValue)
		{
			pbProgress.Maximum = maxValue;
		}

		public void StepProgress()
		{
			pbProgress.Value ++;
		}

		public void SetStatusInfo(String status)
		{
			tbStatus.Text = status;
		}

		public void SetDone(int totalFiles, int totalMatches, int totalTime)
		{
			tbStatus.Text = "All Done\r\n\r\n";
			tbStatus.Text += "Total Files: "+totalFiles+"\r\n";
			tbStatus.Text += "Matches Found: "+totalMatches+"\r\n";
			tbStatus.Text += "Total Time: "+totalTime+" (s)\r\n";
			btCancel.Text = "OK";
			pbProgress.Value = pbProgress.Maximum;
		}

		private void btCancel_Click(object sender, System.EventArgs e)
		{
			MyMP3Cleaner.Stop();
			this.Close();
		}
	}
}
